#!/bin/bash

crossword=$(w3m -dump_source http://www.guardian.co.uk/crossword/quick/ | sed -e '/FORM action/ { /printer/ { s#^[^"]*"\([^"]*\)".*$#http://www.guardian.co.uk\1#; p; }; d; }; d;' | xargs w3m -dump)
#crossword=$(<crossword.txt)

grid=$(echo "$crossword" | sed -e '/┌/,/┘/p; d;')
clues=$(echo "$crossword" | sed -e '/┘/,/\[sp\]/p; d;' | tail -n +3 - | head -n -1)
across_break=$(($(echo "$clues" | sed -e '1{s#Down.*$##; p; }; d;' | wc -c) - 1))
across=$(echo "$clues" | sed -e '2,${s#^\(.\{'$across_break','$across_break'\}\).*$#\1#; p; }; d;')
down=$(echo "$clues" | sed -e '2,${s#^.\{'$across_break','$across_break'\}##; p; }; d;')

function unformat_clues() {
clues=$1
OLDIFS="$IFS"
IFS="
"
firstline=1
for line in $clues; do
    line_formatted=$(echo -n $line | sed -e 's#^[ ]*##; s#[ ]*$##;')
    if [ "${line:0:1}" != " " ]; then
        if [ $firstline -ne 1 ]; then
            echo
        else
            firstline=0
        fi
        echo -n $line_formatted
    else
        if [ "x$line_formatted" != "x" ]; then
            echo -n " "$line_formatted
        fi
    fi
done
IFS="$OLDIFS"
}

function unformat_grid() {
    grid=$1
    echo "$grid" | sed -e '/───/d; s#[0-9]# #g; s#   # #g; s#● *#x#g; s#│##g;'
}

across_unformatted=$(unformat_clues "$across")
down_unformatted=$(unformat_clues "$down")
grid_unformatted=$(unformat_grid "$grid")

echo GRID
echo "$grid_unformatted"
echo
echo ACROSS
echo "$across_unformatted"
echo
echo DOWN
echo "$down_unformatted"
